// class Array_FIFO

extern ofstream file;

template <class DataType>
class Array_FIFO :  public Queue <DataType>, private Array_Structure <DataType>
{
public:
  //////////////////////////////////////////////////////////////
  // Constructors
  // 
	Array_FIFO (int size) :  Array_Structure <DataType> (size) { }

	// copy constructor
	Array_FIFO (const Array_FIFO& source) 
	: Array_Structure <DataType> (source) { }

	Array_FIFO& operator= (const Array_FIFO& source)
	{
		if (this == &source) 
		{ file << "warning self-assignment" << endl; }
		else 
		{ Array_Structure <DataType>::operator=(source); }
		return *this;
	}

  
  //////////////////////////////////////////////////////////////
  // Behaviour methods
  // 
	virtual bool includes (const DataType & element) const
  	{ return Array_Structure <DataType>::includes(element); }
	
	virtual void print() const { Array_Structure <DataType>::print(); }
	
	virtual int get_size() const { return Array_Structure <DataType>::get_size(); }
	
	virtual void enqueue (const DataType & element)
  	{ addFirst(element); }

	virtual DataType dequeue (DequeueEmptyHandler func_ptr)
	  { return removeLast(func_ptr); }
};

