// class List_FIFO

extern ofstream file;

template <class DataType>
class List_FIFO :  public Queue <DataType>, private List_Structure <DataType>
{
public:
  //////////////////////////////////////////////////////////////
  // Constructors
  // 
	List_FIFO () :  List_Structure <DataType> () { }

	// copy constructor
	List_FIFO (const List_FIFO& source) 
	: List_Structure <DataType> (source) { }

	List_FIFO& operator= (const List_FIFO& source)
	{
		if (this == &source) 
		{ file << "warning self-assignment" << endl; }
		else 
		{ List_Structure <DataType>::operator=(source); }
		return *this;
	}

  
  //////////////////////////////////////////////////////////////
  // Behaviour methods
  // 
	virtual bool includes (const DataType & element) const
  	{ return List_Structure <DataType>::includes(element); }
	
	virtual void print() const { List_Structure <DataType>::print(); }
	
	virtual int get_size() const { return List_Structure <DataType>::get_size(); }
	
	virtual void enqueue (const DataType & element)
  	{ addFirst(element); }

	virtual DataType dequeue (DequeueEmptyHandler func_ptr)
	  { return removeLast(func_ptr); }
};

