// class Queue

template <class DataType>
class Queue
{
public:
  ////////////////////////////////////////////////////////////
  // Type definitions; these must correspond with the
  // equivalent type definitions from the implementation
  // classes.
  //
  typedef DataType (*DequeueEmptyHandler)();

public:
	Queue ( )  { }		// do not have to provide
	virtual bool includes(const DataType & element) const = 0;
	virtual void print( ) const = 0;
	virtual int get_size( ) const = 0; 
	virtual void enqueue(const DataType & element) = 0;	 
	virtual DataType dequeue(DequeueEmptyHandler func_ptr) = 0;	 
};
