#include <fstream.h>
#include "implementation.h" //root class for implementation classes
#include "astruct.h" //arrayed structure
#include "queue.h"	//root abstract class
#include "fifo.h"	//fifo interface
#include "lifo.h"	//lifo interface
#include "alifo.h"	//canonical form + data members	
#include "afifo.h"	//canonical form + data members	
#include "lstruct.h" //list structure
#include "llifo.h"	//canonical form + data members		
#include "lfifo.h"	//canonical form + data members	

ofstream file ("project.txt");

int output_invalid (void) // function passed as parameter in remove
{
	file << "Invalid dequeue returning 0 " << endl;
	return  0;
}


void queue_test_1 (Queue <int>* b)
{
// enqueue 51 55 56 55 57 51 59

	file << "enqueueing 51 55 56 55 57 51 59 " << endl;
	b->enqueue(51);
	b->enqueue(55);
	b->enqueue(56);
	b->enqueue(55);
	b->enqueue(57);
	b->enqueue(51);
	b->enqueue(59);


// return the size, print

	file << "\nqueue size: " << b->size() << endl;
	file << "\nqueue print: ";
	b->print();

// dequeue once
	file << "\n dequeueing "<< endl;
	file << b->dequeue(output_invalid) << endl;

// enqueue 55 56 53

	file << "\nenqueueing 55 56 53" << endl;
    b->enqueue(55);
	b->enqueue(56);
	b->enqueue(53);


// return the size, print


	file << "\nqueue size: " << b->size();
	file << "\nqueue print: ";
	b->print();

// verify whether 53, 59, 58 and 51 are in the queue

	file << "\n  53 is ";
	if (!b->includes(53)) file << "not ";
	file << "in queue"<< endl;

	file << "\n  59 is ";
	if (!b->includes(59)) file << "not ";
	file << "in queue"<< endl;

	file << "\n 58 is ";
	if (!b->includes(58)) file << "not ";
	file << "in queue"<< endl;

	file << "\n 51 is ";
	if (!b->includes(51)) file << "not ";
	file << "in queue"<< endl;


// dequeue twice
	file << "\n dequeueing "<< endl;
	file << b->dequeue(output_invalid) << endl;
	file << "\n dequeueing again "<< endl;
	file << b->dequeue(output_invalid) << endl;

	b->print( );
	file << endl;

}

void queue_test_2 (Queue <int>* b)
{
	file << "enqueueing 51 " << endl;
	b->enqueue(51);
	file << "\n dequeueing "<< endl;
	file << b->dequeue(output_invalid) << endl;
	file << "\n dequeueing "<< endl;
	file << b->dequeue(output_invalid) << endl;

	// enqueue 51 55 56 55 57 51 59

	file << "enqueueing 51 55 56 55 57 51 59 " << endl;
	b->enqueue(51);
	b->enqueue(55);
	b->enqueue(56);
	b->enqueue(55);
	b->enqueue(57);
	b->enqueue(51);
	b->enqueue(59);

	file << "\nqueue size: " << b->size();
	file << "\nqueue print: ";
	b->print();

}


int main (void)
{
	int Array_SIZE = 20;

	file << "Answers homework 3 \n";
	file << " Queue <int> Test 1: basic operations" << endl;
	
        file << "Array FIFO test with ints:  " << endl;
	Queue <int>* t1 = new Array_FIFO <int>(Array_SIZE);
	queue_test_1 (t1);
	file << endl;
	
	file << "Array LIFO test with ints:  " << endl;
	Queue <int>* t2 =  new Array_LIFO <int>(Array_SIZE);
	queue_test_1 (t2);
	file << endl;

	file << "List FIFO test with ints:  " << endl;
	Queue <int>* t3 = new List_FIFO <int>;
	queue_test_1 (t3);
	file << endl;
	
	file << "List LIFO test with ints:  " << endl;
	Queue <int>* t4 =  new List_LIFO <int>;
	queue_test_1 (t4);
	file << endl;

	delete t1,t2,t3,t4;

	file << " Queue <int> Test 2: overflow/underflow" << endl;

	Array_SIZE = 4;

	file << "Array FIFO test with ints:  " << endl;
	Queue <int>* r1 = new Array_FIFO <int>(Array_SIZE);
	queue_test_2 (r1);
	file << endl;
	
	file << "Array LIFO test with ints:  " << endl;
	Queue <int>* r2 =  new Array_LIFO <int>(Array_SIZE);
	queue_test_2 (r2);
	file << endl;

	file << "List FIFO test with ints:  " << endl;
	Queue <int>* r3 = new List_FIFO <int>;
	queue_test_2 (r3);
	file << endl;
	
	file << "List LIFO test with ints:  " << endl;
	Queue <int>* r4 =  new List_LIFO <int>;
	queue_test_2 (r4);
	file << endl;

	delete r1,r2,r3,r4;

	file << " Queue <int> Test 3: canonical form" << endl;

	Array_SIZE = 10;

	file << "Array FIFO test with ints:  " << endl;
	Array_FIFO <int> z1(Array_SIZE);
	z1.enqueue (61); z1.enqueue (62);
	Array_FIFO <int> zz1 (z1);
	z1.enqueue(63);
	file << "printing z1: should be 63 62 61 " << endl;
	z1.print ();
	file << "printing zz1: should be 62 61 " << endl;
	zz1.print ();
	file << endl;
	z1 = z1; //should print warning about self assignment to file
	Array_FIFO <int> z2(Array_SIZE);
	z2.enqueue (99);
	z2 = z1;
	z1.enqueue (64);
	file << "printing z1: should be 64 63 62 61 " << endl;
	z1.print ();
	file << "printing z2: should be 63 62 61 " << endl;
	z2.print ();
	
	file << "Array LIFO test with ints:  " << endl;
	Array_LIFO <int> k1 (Array_SIZE);
	k1.enqueue (61); k1.enqueue (62);
	Array_LIFO <int> kk1 (k1);
	k1.enqueue(63);
	file << "printing k1: should be 63 62 61 " << endl;
	k1.print ();
	file << "printing kk1: should be 62 61 " << endl;
	kk1.print ();
	file << endl;
	k1 = k1; //should print warning about self assignment to file
	Array_LIFO <int> k2 (Array_SIZE);
	k2.enqueue (99);
	k2 = k1;
	k1.enqueue (64);
	file << "printing k1: should be 64 63 62 61 " << endl;
	k1.print ();
	file << "printing k2: should be 63 62 61 " << endl;
	k2.print ();

	file << "List FIFO test with ints:  " << endl;
	List_FIFO <int> q1;
	q1.enqueue (61); q1.enqueue (62);
	List_FIFO <int> qq1 (q1);
	q1.enqueue(63);
	file << "printing q1: should be 63 62 61 " << endl;
	q1.print ();
	file << "printing qq1: should be 62 61 " << endl;
	qq1.print ();
	file << endl;
	q1 = q1; //should print warning about self assignment to file"
	List_FIFO <int> q2;
	q2.enqueue (99);
	q2 = q1;
	q1.enqueue (64);
	file << "printing q1: should be 64 63 62 61 " << endl;
	q1.print ();
	file << "printing q2: should be 63 62 61 " << endl;
	q2.print ();
	
	file << "List LIFO test with ints:  " << endl;
	List_LIFO <int> l1;
	l1.enqueue (61); l1.enqueue (62);
	List_LIFO <int> ll1 (l1);
	l1.enqueue(63);
	file << "printing l1: should be 63 62 61 " << endl;
	l1.print ();
	file << "printing ll1: should be 62 61 " << endl;
	ll1.print ();
	file << endl;
	l1 = l1; //should print warning about self assignment to file
	List_LIFO <int> l2;
	l2.enqueue (99);
	l2 = l1;
	l1.enqueue (64);
	file << "printing l1: should be 64 63 62 61 " << endl;
	l1.print ();
	file << "printing l2: should be 63 62 61 " << endl;
	l2.print ();

 
	return 0;
}

