// class Queue

template <class DataType>
class Queue
{
protected:
   ImplementationClass <DataType> *  mystruct;

public:
  ////////////////////////////////////////////////////////////
  // Type definitions; must correspond to the definitions in
  // ImplementationClass.
  //
  typedef ImplementationClass <DataType>::DequeueEmptyHandler DequeueEmptyHandler;

public:
	// constructor, not necessary
	Queue ()  { }
	// includes
	bool includes (const DataType & element) const
  	{ return mystruct -> includes(element); }
	void print () const
  	{ mystruct -> print( ); }
	int size () const
  	{ return mystruct -> get_size( ); }
	// enqueue
	void enqueue (const DataType & element)
  	{ mystruct -> addFirst(element); }
	virtual DataType dequeue (DequeueEmptyHandler func_ptr) = 0; 

  	virtual ~Queue() {}
};
