// The implementation class

template <class DataType>
class ImplementationClass
{
protected:
  ////////////////////////////////////////////////////////////
  // State
  //
  int size;

  ////////////////////////////////////////////////////////////
  // Constructors:  only allow construction from subclasses.
  //
  ImplementationClass() : size(0) {}
  ImplementationClass(const ImplementationClass &i) : size(i.size) {}

public:
  ////////////////////////////////////////////////////////////
  // Type definitions
  //
  typedef DataType (*DequeueEmptyHandler)();

  int get_size() const { return size; }
  virtual bool includes(const DataType & element) const = 0;
  virtual void addLast(const DataType & element) = 0;

  // Function addFirst is provided for completeness.
  // It is not used in the present assignment
  virtual void addFirst(const DataType & element) = 0;
  virtual DataType removeFirst(DequeueEmptyHandler func_ptr) = 0;
  virtual DataType removeLast(DequeueEmptyHandler func_ptr) = 0;
  virtual void print() const = 0;
};

